<?php
namespace Controller;

use Zeedhi\Framework\DTO\Response\Message;
use Zeedhi\Framework\DTO\Response;
use Zeedhi\Framework\DTO\Request;
use \Util\Exception;

class PromocoesInt {

	protected $PromocoesIntService;
	protected $util;
	protected $entityManager;
	
	public function __construct(
		\Service\PromocoesInt $PromocoesIntService,
		\Util\Util $util,
		\Doctrine\ORM\EntityManager $entityManager
		){
		$this->PromocoesIntService = $PromocoesIntService;
		$this->util                   = $util;
		$this->entityManager          = $entityManager;
	}
	public function EnviaCarrinhoPromocoesInt(Request\Filter $request, Response $response) {
		try {
			$params = $request->getFilterCriteria()->getConditions();

			$chave = $params[0]['value'];
			$session = $this->util->getSessionVars($chave);
			$NRCOMANDA = $params[1]['value'];
			$NRCPFINTEPROMO = $params[2]['value'];
			$Produtos = $params[3]['value'];
			$posicoes 		= $params[4]['value'];

			$arrParametros = array();
			$arrParametros['branchCode'] = $session['CDFILIAL'];
			$arrParametros['orderChannel'] = 1;
			$arrParametros['orderModality'] = 'BAL';
			$arrParametros['clientDocument'] = $NRCPFINTEPROMO;
			$arrParametros['coupon'] = null;
			$OrderDate = (new \DateTime('NOW', new \DateTimeZone('America/Bahia')))->format('Y-m-d')."T".(new \DateTime('NOW', new \DateTimeZone('America/Bahia')))->format('H:i:s');
			$arrParametros['orderDate'] = $OrderDate;
			$arrParametros['products'] = array();
			$params = array( $session['CDFILIAL'], $NRCOMANDA );
			if(empty($Produtos)){
				if(empty($posicoes)){
				$Produtos = $this->entityManager->getConnection()->fetchAll("SQL_ITENS_COMANDAS", $params);
				} else {
					foreach ($posicoes as &$pos){
						$pos = floatval($pos)+1;
						$pos = str_pad($pos, 2, '0', STR_PAD_LEFT);
					}
					$params = array(
						'CDFILIAL'=>$session['CDFILIAL'],'NRCOMANDA'=>$NRCOMANDA,'NRLUGARMESA'=>$posicoes
					);
					$type = array(
						'NRLUGARMESA' => \Doctrine\DBAL\Connection::PARAM_STR_ARRAY
					);
					$Produtos = $this->entityManager->getConnection()->fetchAll("SQL_ITENS_COMANDAS_POSICAO", $params, $type);
				}
			}
			foreach ($Produtos as $produto){
				if(!isset($produto["DTHRINCOMVEN"])){
					$produto["DTHRINCOMVEN"] = null;
				}
				if(empty($produto["DTHRINCOMVEN"])){
					$produto["DTHRINCOMVEN"] = (new \DateTime('NOW', new \DateTimeZone('America/Bahia')))->format('Y-m-d')."T".(new \DateTime('NOW', new \DateTimeZone('America/Bahia')))->format('H:i:s');
				}
				array_push($arrParametros['products'],
					array( "data"=>
						array(
							"index" => ltrim($produto["NRPRODCOMVEN"], "0"),
							"productCode" => $produto["CDPRODUTO"],
							"quantity" => $produto["QTPRODCOMVEN"],
							"value" => round($produto["VRPRECCOMVEN"], 2),
							"originValue" => round($produto["VRPRECCOMVEN"], 2),
							"createdAt" => (new \DateTime($produto["DTHRINCOMVEN"]))->format('Y-m-d')."T".(new \DateTime($produto["DTHRINCOMVEN"]))->format('H:i:s')
						)						
					)
				);
			}
			$result = $this->PromocoesIntService->EnviaCarrinhoPromocoesInt($arrParametros);
		} catch (\Exception $e) {
			Exception::logException($e);
			$result = array('error' => true,'message' => $e->getMessage());
		}
		$response->addDataSet(new \Zeedhi\Framework\DataSource\DataSet('EnviaCarrinhoPromocoesInt', $result));
	}
	public function SalvaPromocoesInt(Request\Filter $request, Response $response) {
		try {
			$params = $request->getFilterCriteria()->getConditions();
			$chave = $params[0]['value'];
			$session = $this->util->getSessionVars($chave);
			$NRVENDAREST  	= $params[1]['value'];
			$NRCOMANDA  	= $params[2]['value'];
			$NRCPFINTEPROMO = $params[3]['value'];
			$IDPEDINTEPROMO = $params[4]['value'];
			$PromocoesInt   = $params[5]['value'];
			$arrPROMOCOMANDA = array();
			if($PromocoesInt!=null){
				$PromocoesInt = json_decode($PromocoesInt,true);
				if(!empty($PromocoesInt)){
					if(!empty($PromocoesInt["offers"])){
						foreach ( $PromocoesInt["offers"]["data"] as $arrOffers ){
							if(!isset($arrOffers['applied']['data']['IDUTPROMOCOM'])){
								continue;
							}
							if($arrOffers['applied']['data']['IDUTPROMOCOM']=='S'){
								$arrOffers['IDPROMOCOM'] = $arrOffers['applied']['data']['id'];
								$arrOffers['NMPROMOCOM'] = $arrOffers['applied']['data']['name'];
								$arrOffers['DSPROMOCOM'] = $arrOffers['applied']['data']['description'];
								if(is_array($arrOffers['DSPROMOCOM'])){
									if(isset($arrOffers['DSPROMOCOM'][0])){
										$arrOffers['DSPROMOCOM'] =$arrOffers['DSPROMOCOM'][0];
									} else {
										$arrOffers['DSPROMOCOM'] = null;
									}
								}
								$arrOffers['IDTPPROMOCOM'] = 'O'; // O P W
								$arrOffers['IDTPDESCPROMO'] = null; // V P
								$arrOffers['VRDESCPROMO'] = null;
								$arrOffers['VRVENDAPROMO'] = $arrOffers['total'];
								$arrOffers['IDUTPROMOCOM'] = 'S'; // S N
								array_push($arrPROMOCOMANDA, $arrOffers );
							}
						}
					}
					if(!empty($PromocoesInt["paymentsOffer"])){
						foreach ( $PromocoesInt["paymentsOffer"]["data"] as $arrpaymentsOffer ){
							if($arrpaymentsOffer['discountType'] != '1' && $arrpaymentsOffer['discountType'] != '2'){
								continue;
							}
							$arrpaymentsOffer['IDPROMOCOM'] = $arrpaymentsOffer['paymentCode'];
							$arrpaymentsOffer['NMPROMOCOM'] = $arrpaymentsOffer['name'];
							$arrpaymentsOffer['DSPROMOCOM'] = null;
							$arrpaymentsOffer['IDTPPROMOCOM'] = 'P'; // O P W
							if($arrpaymentsOffer['discountType'] == '1'){
								$arrpaymentsOffer['IDTPDESCPROMO'] =  'V';
							} else if($arrpaymentsOffer['discountType'] == '2'){
								$arrpaymentsOffer['IDTPDESCPROMO'] ='P';
							}
							$arrpaymentsOffer['VRDESCPROMO'] = $arrpaymentsOffer['discountValue'];
							$arrpaymentsOffer['VRVENDAPROMO'] = null;
							$arrpaymentsOffer['IDUTPROMOCOM'] = 'N'; // S N
							array_push($arrPROMOCOMANDA, $arrpaymentsOffer );
						}
					}
					if(!empty($PromocoesInt["wallet"])){
						if($PromocoesInt["wallet"]['type'] == '1' || $PromocoesInt["wallet"]['type'] == '2'){
							$PromocoesInt["wallet"]['IDPROMOCOM'] = null;
							$PromocoesInt["wallet"]['NMPROMOCOM'] = null;
							$PromocoesInt["wallet"]['DSPROMOCOM'] = null;
							$PromocoesInt["wallet"]['IDTPPROMOCOM'] = 'W'; // O P W
							if($PromocoesInt["wallet"]['type'] == '1'){
								$PromocoesInt["wallet"]['IDTPDESCPROMO'] = 'V';
							} else if($PromocoesInt["wallet"]['type'] == '2'){
								$PromocoesInt["wallet"]['IDTPDESCPROMO'] = 'P';
							}
							$PromocoesInt["wallet"]['VRDESCPROMO'] = $PromocoesInt["wallet"]['value'];
							$PromocoesInt["wallet"]['VRVENDAPROMO'] = null;
							$PromocoesInt["wallet"]['IDUTPROMOCOM'] = 'N'; // S N
							array_push($arrPROMOCOMANDA, $PromocoesInt["wallet"] );
						}
					}
				}
			}
			$result = $this->PromocoesIntService->SalvaPromocoesInt($session['CDFILIAL'],$NRVENDAREST,$NRCOMANDA,$NRCPFINTEPROMO,$IDPEDINTEPROMO,$arrPROMOCOMANDA);
		} catch (\Exception $e) {
			Exception::logException($e);
			$result = array('error' => true,'message' => $e->getMessage());
		}
		$response->addDataSet(new \Zeedhi\Framework\DataSource\DataSet('SalvaPromocoesInt', $result));
	}
	public function ConsultaPromocoesInt(Request\Filter $request, Response $response) {
		try {
			$params = $request->getFilterCriteria()->getConditions();
			$IDPEDINTEPROMO	= $params[0]['value'];
			$result = $this->PromocoesIntService->ConsultaPromocoesInt(array('orderId'=>$IDPEDINTEPROMO));
		} catch (\Exception $e) {
			Exception::logException($e);
			$result = array('error' => true,'message' => $e->getMessage());
		}
		$response->addDataSet(new \Zeedhi\Framework\DataSource\DataSet('ConsultaPromocoesInt', $result));
	}
	public function listPromocoesInt(Request\Filter $request, Response $response) {
		$params = $request->getFilterCriteria()->getConditions();
		$retorno = array();
		if(isset($params[0])){
			if($params[0]['value']!=""){
				$retorno = $params[0]['value'];
			}
		}
		$response->addDataSet(new \Zeedhi\Framework\DataSource\DataSet('ConsultaPromocoesInt', $retorno));
	}
	public function BuscaPromocoesInt(Request\Filter $request, Response $response) {
		try {
			$params = $request->getFilterCriteria()->getConditions();
			$chave = $params[0]['value'];
			$session = $this->util->getSessionVars($chave);
			$NRVENDAREST  	= $params[1]['value'];
			$NRCOMANDA  	= $params[2]['value'];
			$IDTPPROMOCOM	= isset($params[3])?$params[3]['value']:'T';
			if(isset($params[4])){
				if($params[4]['value']!=""){
					$retorno = $params[4]['value'];
					$response->addDataSet(new \Zeedhi\Framework\DataSource\DataSet('ConsultaPromocoesInt', $retorno));
					return;
				}
			}
			$result = $this->PromocoesIntService->BuscaPromocoesInt($session['CDFILIAL'], $NRVENDAREST, $NRCOMANDA, $IDTPPROMOCOM);
			if(!$result){
				$result = array();
			}
		} catch (\Exception $e) {
			Exception::logException($e);
			$result = array('error' => true,'message' => $e->getMessage());
		}
		$response->addDataSet(new \Zeedhi\Framework\DataSource\DataSet('ConsultaPromocoesInt', $result));
	}
	public function AtualizaPromocoesInt(Request\Filter $request, Response $response) {
		try {
			$params = $request->getFilterCriteria()->getConditions();
			$chave = $params[0]['value'];
			$session = $this->util->getSessionVars($chave);
			$NRVENDAREST  	   = $params[1]['value'];
			$NRCOMANDA  	   = $params[2]['value'];
			$arrayPromocoesInt = $params[3]['value'];
			$result = $this->PromocoesIntService->AtualizaPromocoesInt($session['CDFILIAL'], $NRVENDAREST, $NRCOMANDA,null,'N');
			foreach ($arrayPromocoesInt as $arr) {
				$IDUTPROMOCOM = $arr['IDUTPROMOCOM'];
				$NRSEQPROMOCOM = $arr['NRSEQPROMOCOM'];
				$result = $this->PromocoesIntService->AtualizaPromocoesInt($session['CDFILIAL'], $NRVENDAREST, $NRCOMANDA,$NRSEQPROMOCOM,$IDUTPROMOCOM);
			}
			if(!$result){
				$result = array();
			}
		} catch (\Exception $e) {
			Exception::logException($e);
			$result = array('error' => true,'message' => $e->getMessage());
		}
		$response->addDataSet(new \Zeedhi\Framework\DataSource\DataSet('ConsultaPromocoesInt', $result));
	}
}