<?php
namespace Service;

use \SimpleXMLElement;

class FidelidadeUDS {

    protected $entityManager;
	protected $util;
	protected $FidelidadeUDSServiceAPI;
	
	public function __construct(
		\Doctrine\ORM\EntityManager $entityManager, 
		\Util\Util $util,
		\Odhen\API\Service\FidelidadeUDS $FidelidadeUDSServiceAPI
	){
		$this->entityManager = $entityManager;
		$this->util = $util;
		$this->FidelidadeUDSServiceAPI = $FidelidadeUDSServiceAPI;
	}

	public function SalvaFidelidadeUDS($CDFILIAL,$CDLOJA,$CDCAIXA,$NRVENDAREST,$NRCOMANDA,$NRCPFFIDUDS,$VRDESCCASHUDS) {
		if(!empty($NRCPFFIDUDS)){
			$paramsUpdate = array();
			$paramsUpdate['CDFILIAL'] = $CDFILIAL;
			$paramsUpdate['CDLOJA'] = $CDLOJA;
			$paramsUpdate['CDCAIXA'] = $CDCAIXA;
			$paramsUpdate['NRVENDAREST'] = $NRVENDAREST;
			$paramsUpdate['NRCOMANDA'] = $NRCOMANDA;
			$paramsUpdate['NRCPFFIDUDS'] = $NRCPFFIDUDS;
			$paramsUpdate['VRDESCCASHUDS'] = $VRDESCCASHUDS;
			/*
			$params = array(
				$CDFILIAL,
				$NRCOMANDA
			);
			$ITEMVENDA = $this->entityManager->getConnection()->fetchAll("SQL_ITENS_COMANDAS", $params);
			$arrayPrePedido = $this->arrayUDSPrePedido(
				$paramsUpdate,
				$ITEMVENDA
			);
			try {
				$this->FidelidadeUDSServiceAPI->transmitePrePedido($arrayPrePedido);
			} catch(\Exception $ee){
				//throw $e;
			}
			*/
		}
		$params = array (
			'CDFILIAL' => $CDFILIAL,
			'NRVENDAREST' => $NRVENDAREST,
			'NRCOMANDA' => $NRCOMANDA,
			'NRCPFFIDUDS' => $NRCPFFIDUDS,
			'VRDESCCASHUDS' => $VRDESCCASHUDS
		);
		$this->entityManager->getConnection()->fetchAssoc("UPDATE_COMANDAVEN_FIDELIDADEUDS", $params);
		return array('error' => false,'message' => 'Informação salva com sucesso');
	}

	public function ConsultaFidelidadeUDS($NRCPFFIDUDS, $valorVendaBruto, $CDFILIAL, $NRVENDAREST, $NRCOMANDA, $CDCLIENTE, $CDCONSUMIDOR) {
		$origemVenda = 'BAL_FOS';
		$cdTipoCons = "null";
				if(!empty($CDCLIENTE) && !empty($CDCONSUMIDOR)){
			$params = array ( $CDCLIENTE, $CDCONSUMIDOR );
			$arrDadosConsulta = $this->entityManager->getConnection()->fetchAssoc("TIPO_CONSUMIDOR", $params);
			$CDCLIENTE = $arrDadosConsulta['CDCLIENTE'];
			$cdTipoCons = $arrDadosConsulta['CDTIPOCONS'];
		}
		if(!empty($NRVENDAREST) && !empty($NRCOMANDA)){
			$params = array ( 'CDFILIAL' => $CDFILIAL, 'NRVENDAREST' => $NRVENDAREST, 'NRCOMANDA' => $NRCOMANDA );
			$arrDadosConsulta = $this->entityManager->getConnection()->fetchAssoc("SQL_BUSCA_DADOS_CONSULTA_UDS", $params);
			$origemVenda = $arrDadosConsulta['IDORGCMDVENDA'];
			$CDCLIENTE = $arrDadosConsulta['CDCLIENTE'];
			$cdTipoCons = $arrDadosConsulta['CDTIPOCONS'];
		}
		$params = array(
			'cpfCli' 		  => $NRCPFFIDUDS,
			"valorVendaBruto" => $valorVendaBruto,
			"origemVenda" 	  => $origemVenda,
			"cdFilial" 		  => $CDFILIAL,
			"cdCliente" 	  => $CDCLIENTE,
			"cdTipoCons" 	  => empty($cdTipoCons)?"null":$cdTipoCons
		);
		$arrRetorno =  $this->FidelidadeUDSServiceAPI->consultaFidelidadeUDS($params);
		return $arrRetorno;
	}

	public function arrayUDSPrePedido(
        $paramsUpdate, $ITEMVENDA
    ){
        $arrProdutos = array();
        foreach ($ITEMVENDA as $product){
            $productArray = array(
                "idProduto" => $product["CDPRODUTO"],
				"descProduto" => $product["NMPRODUTO"],
                "quantidade" => $product["QTPRODCOMVEN"],
                "valor" => array(
					"unitario" => round($product["VRPRECCOMVEN"], 2),
                    "acrescimo" => round($product["VRACRCOMVEN"]),
                    "desconto" => round($product["VRDESCCOMVEN"])
                )
            );
            array_push($arrProdutos, array( "data"=>$productArray) );
        }

        return array(
            "idEstabelecimento" => $paramsUpdate['CDFILIAL'],
            "codigoLoja" => $paramsUpdate['CDLOJA'],
            "idInterface" => $paramsUpdate['CDCAIXA'],
            "tipoInterface" => 1,
            "idPedido" =>  $paramsUpdate['CDFILIAL'].$paramsUpdate['NRVENDAREST'].$paramsUpdate['NRCOMANDA'],
            "conteudoPedido" =>$arrProdutos,
            "statusPedido" => 0,
            "usarCashback" => ( $paramsUpdate['VRDESCCASHUDS'] > 0 ? 'true' : 'false' ),
            "cpfCli" => $paramsUpdate['NRCPFFIDUDS'],
			"timestamp" => (new \DateTime('NOW', new \DateTimeZone('America/Bahia')))->format('Y-m-d')."T".(new \DateTime('NOW', new \DateTimeZone('America/Bahia')))->format('H:i:s'),
            "atualizado" => 'false'
        );
	}
}